<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: canvas_drawing_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_70c39dc1b82fcbfdf59a9faab30d27c1.html">gui_widgets</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">canvas_drawing_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2005  Davis E. King (davis@dlib.net), and Nils Labugt</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_GUI_CANVAS_DRAWINg_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_GUI_CANVAS_DRAWINg_ABSTRACT_ </span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../gui_core.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../pixel.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        &gt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keywordtype">void</span> draw_line (</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">const</span> point&amp; p1,</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keyword">const</span> point&amp; p2,</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel = rgb_pixel(0,0,0),</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    );</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        &gt;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> draw_rectangle (</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        rectangle rect,</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel = rgb_pixel(0,0,0),</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    );</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        &gt;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> draw_circle (</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> point&amp; center_point,</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordtype">double</span> radius,</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel = rgb_pixel(0,0,0),</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    );</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        &gt;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">void</span> draw_pixel (</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keyword">const</span> point&amp; p,</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel </div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    );</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        &gt;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">void</span> draw_solid_circle (</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keyword">const</span> point&amp; center_point,</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="keywordtype">double</span> radius,</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel = rgb_pixel(0,0,0),</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    );</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        &gt;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordtype">void</span> draw_solid_convex_polygon (</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">const</span> std::vector&lt;point&gt;&amp; polygon,</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel = rgb_pixel(0,0,0),</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    );</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="keywordtype">void</span> draw_button_down (</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keyword">const</span> rectangle&amp; btn,</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> alpha = 255</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    );</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160; </div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="keywordtype">void</span> draw_sunken_rectangle (</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="keyword">const</span> rectangle&amp; border,</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> alpha = 255</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    );</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160; </div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keywordtype">void</span> draw_button_up (</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keyword">const</span> rectangle&amp; btn,</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> alpha = 255</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    );</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        &gt;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordtype">void</span> draw_checkered (</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <span class="keyword">const</span> rectangle&amp; area,</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel1,</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel2</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    );</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160; </div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keyword">typename</span> image_type </div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        &gt;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <span class="keywordtype">void</span> draw_image (</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        <span class="keyword">const</span> canvas&amp; c</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        <span class="keyword">const</span> point&amp; p,</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keyword">const</span> image_type&amp; <a class="code" href="classdlib_1_1array2d.html">image</a>,</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    );</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160; </div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keyword">typename</span> image_type </div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        &gt;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keywordtype">void</span> draw_image (</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    );</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160; </div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        &gt;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keywordtype">void</span> fill_rect (</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    );</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160; </div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        &gt;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    <span class="keywordtype">void</span> fill_rect_with_vertical_gradient (</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel_top,</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">const</span> pixel_type&amp; pixel_bottom,</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    );</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160; </div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        &gt;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="keywordtype">void</span> fill_gradient_rounded (</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> radius,</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        <span class="keyword">const</span> pixel_type&amp; top_color,</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        <span class="keyword">const</span> pixel_type&amp; bottom_color,</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    );</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160; </div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        <span class="keyword">typename</span> pixel_type</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        &gt;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    <span class="keywordtype">void</span> draw_rounded_rectangle (</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;        <span class="keyword">const</span> canvas&amp; c,</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        <span class="keywordtype">unsigned</span> radius,</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="keyword">const</span> pixel_type&amp; color,</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        <span class="keyword">const</span> rectangle&amp; area = rectangle(-infinity,-infinity,infinity,infinity)</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    );</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160; </div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;}</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160; </div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;<span class="preprocessor">#endif // DLIB_GUI_CANVAS_DRAWINg_ABSTRACT_</span></div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1array2d_html"><div class="ttname"><a href="classdlib_1_1array2d.html">dlib::array2d&lt; hsi_pixel &gt;</a></div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
